import CountryRegionViewer from "@/components/rendering/countryRegionViewer";
import PlansHeroBanner from "@/components/rendering/plansHeroBanner";
import { getAllCountryRegion } from "@/utils/api/countryRegion";
import Head from "next/head";
import { useEffect, useState } from "react";

export default function PlansPage({ response }: any) {
  const [loading, setLoading] = useState(true);
  const [data, setData] = useState<any>({
    sortedCountries: null,
    sortedRegions: null,
  });

  const [pageCount, setPageCount] = useState(1);
  const [isNextPage, setIsnextPage] = useState(false);

  async function fetchData() {
    setLoading(true);
    try {
      const { isError, response } = await getAllCountryRegion({
        is_popular: false,
        page: pageCount,
      });

      setIsnextPage(
        response?.data?.country_next_url?.length > 0 ? true : false
      );

      if (data?.sortedCountries) {
        setData({
          ...data,
          sortedCountries: [
            ...data?.sortedCountries,
            ...response?.data?.countries,
          ],
        });
      } else {
        setData({
          ...data,
          sortedCountries: response?.data?.countries,
          sortedRegions: response?.data?.regions,
        });
      }

      setLoading(false);
    } catch (error) {
      console.error(error);
      setLoading(false);
    }
  }

  useEffect(() => {
    fetchData();
  }, [pageCount]);

  return (
    <>
      <Head>
        <title>WaoSim | Plans</title>
        <meta name="description" content="Generated by create next app" />
        <meta name="viewport" content="width=device-width, initial-scale=1" />
        <meta
          property="og:image"
          content="https://stagecdn.waosim.com/landingpage/assets/thumbnail/homeThumbnail.png"
        />
        <link rel="icon" href="/faviconIcon.svg" />
      </Head>
      <main>
        <PlansHeroBanner />
        <CountryRegionViewer
          data={data}
          loading={loading}
          setPageCount={setPageCount}
          pageCount={pageCount}
          isNextPage={isNextPage}
        />
      </main>
    </>
  );
}

// export async function getServerSideProps({ req }: any) {
//   const { isError, response } = await getAllCountryRegion();

//   return {
//     props: {
//       response: response?.data,
//     },
//   };
// }
